var stdCurrency = {
    // AED currency object
    AED: { code: "AED", name: "UAE Dirham" minorUnits: 2, factor: 100},
    // AFN currency object
    AFN: { code: "AFN", name: "Afghani" minorUnits: 2, factor: 100},
    // ALL currency object
    ALL: { code: "ALL", name: "Lek" minorUnits: 2, factor: 100},
    // AMD currency object
    AMD: { code: "AMD", name: "Armenian Dram" minorUnits: 2, factor: 100},
    // ANG currency object
    ANG: { code: "ANG", name: "Netherlands Antillean Guilder" minorUnits: 2, factor: 100},
    // AOA currency object
    AOA: { code: "AOA", name: "Kwanza" minorUnits: 2, factor: 100},
    // ARS currency object
    ARS: { code: "ARS", name: "Argentine Peso" minorUnits: 2, factor: 100},
    // AUD currency object
    AUD: { code: "AUD", name: "Australian Dollar" minorUnits: 2, factor: 100},
    // AWG currency object
    AWG: { code: "AWG", name: "Aruban Florin" minorUnits: 2, factor: 100},
    // AZN currency object
    AZN: { code: "AZN", name: "Azerbaijan Manat" minorUnits: 2, factor: 100},
    // BAM currency object
    BAM: { code: "BAM", name: "Convertible Mark" minorUnits: 2, factor: 100},
    // BBD currency object
    BBD: { code: "BBD", name: "Barbados Dollar" minorUnits: 2, factor: 100},
    // BDT currency object
    BDT: { code: "BDT", name: "Taka" minorUnits: 2, factor: 100},
    // BGN currency object
    BGN: { code: "BGN", name: "Bulgarian Lev" minorUnits: 2, factor: 100},
    // BHD currency object
    BHD: { code: "BHD", name: "Bahraini Dinar" minorUnits: 3, factor: 1000},
    // BIF currency object
    BIF: { code: "BIF", name: "Burundi Franc" minorUnits: 0, factor: 1},
    // BMD currency object
    BMD: { code: "BMD", name: "Bermudian Dollar" minorUnits: 2, factor: 100},
    // BND currency object
    BND: { code: "BND", name: "Brunei Dollar" minorUnits: 2, factor: 100},
    // BOB currency object
    BOB: { code: "BOB", name: "Boliviano" minorUnits: 2, factor: 100},
    // BOV currency object
    BOV: { code: "BOV", name: "Mvdol" minorUnits: 2, factor: 100},
    // BRL currency object
    BRL: { code: "BRL", name: "Brazilian Real" minorUnits: 2, factor: 100},
    // BSD currency object
    BSD: { code: "BSD", name: "Bahamian Dollar" minorUnits: 2, factor: 100},
    // BTN currency object
    BTN: { code: "BTN", name: "Ngultrum" minorUnits: 2, factor: 100},
    // BWP currency object
    BWP: { code: "BWP", name: "Pula" minorUnits: 2, factor: 100},
    // BYN currency object
    BYN: { code: "BYN", name: "Belarusian Ruble" minorUnits: 2, factor: 100},
    // BZD currency object
    BZD: { code: "BZD", name: "Belize Dollar" minorUnits: 2, factor: 100},
    // CAD currency object
    CAD: { code: "CAD", name: "Canadian Dollar" minorUnits: 2, factor: 100},
    // CDF currency object
    CDF: { code: "CDF", name: "Congolese Franc" minorUnits: 2, factor: 100},
    // CHE currency object
    CHE: { code: "CHE", name: "WIR Euro" minorUnits: 2, factor: 100},
    // CHF currency object
    CHF: { code: "CHF", name: "Swiss Franc" minorUnits: 2, factor: 100},
    // CHW currency object
    CHW: { code: "CHW", name: "WIR Franc" minorUnits: 2, factor: 100},
    // CLF currency object
    CLF: { code: "CLF", name: "Unidad de Fomento" minorUnits: 4, factor: 10000},
    // CLP currency object
    CLP: { code: "CLP", name: "Chilean Peso" minorUnits: 0, factor: 1},
    // CNY currency object
    CNY: { code: "CNY", name: "Yuan Renminbi" minorUnits: 2, factor: 100},
    // COP currency object
    COP: { code: "COP", name: "Colombian Peso" minorUnits: 2, factor: 100},
    // COU currency object
    COU: { code: "COU", name: "Unidad de Valor Real" minorUnits: 2, factor: 100},
    // CRC currency object
    CRC: { code: "CRC", name: "Costa Rican Colon" minorUnits: 2, factor: 100},
    // CUC currency object
    CUC: { code: "CUC", name: "Peso Convertible" minorUnits: 2, factor: 100},
    // CUP currency object
    CUP: { code: "CUP", name: "Cuban Peso" minorUnits: 2, factor: 100},
    // CVE currency object
    CVE: { code: "CVE", name: "Cabo Verde Escudo" minorUnits: 2, factor: 100},
    // CZK currency object
    CZK: { code: "CZK", name: "Czech Koruna" minorUnits: 2, factor: 100},
    // DJF currency object
    DJF: { code: "DJF", name: "Djibouti Franc" minorUnits: 0, factor: 1},
    // DKK currency object
    DKK: { code: "DKK", name: "Danish Krone" minorUnits: 2, factor: 100},
    // DOP currency object
    DOP: { code: "DOP", name: "Dominican Peso" minorUnits: 2, factor: 100},
    // DZD currency object
    DZD: { code: "DZD", name: "Algerian Dinar" minorUnits: 2, factor: 100},
    // EGP currency object
    EGP: { code: "EGP", name: "Egyptian Pound" minorUnits: 2, factor: 100},
    // ERN currency object
    ERN: { code: "ERN", name: "Nakfa" minorUnits: 2, factor: 100},
    // ETB currency object
    ETB: { code: "ETB", name: "Ethiopian Birr" minorUnits: 2, factor: 100},
    // EUR currency object
    EUR: { code: "EUR", name: "Euro" minorUnits: 2, factor: 100},
    // FJD currency object
    FJD: { code: "FJD", name: "Fiji Dollar" minorUnits: 2, factor: 100},
    // FKP currency object
    FKP: { code: "FKP", name: "Falkland Islands Pound" minorUnits: 2, factor: 100},
    // GBP currency object
    GBP: { code: "GBP", name: "Pound Sterling" minorUnits: 2, factor: 100},
    // GEL currency object
    GEL: { code: "GEL", name: "Lari" minorUnits: 2, factor: 100},
    // GHS currency object
    GHS: { code: "GHS", name: "Ghana Cedi" minorUnits: 2, factor: 100},
    // GIP currency object
    GIP: { code: "GIP", name: "Gibraltar Pound" minorUnits: 2, factor: 100},
    // GMD currency object
    GMD: { code: "GMD", name: "Dalasi" minorUnits: 2, factor: 100},
    // GNF currency object
    GNF: { code: "GNF", name: "Guinean Franc" minorUnits: 0, factor: 1},
    // GTQ currency object
    GTQ: { code: "GTQ", name: "Quetzal" minorUnits: 2, factor: 100},
    // GYD currency object
    GYD: { code: "GYD", name: "Guyana Dollar" minorUnits: 2, factor: 100},
    // HKD currency object
    HKD: { code: "HKD", name: "Hong Kong Dollar" minorUnits: 2, factor: 100},
    // HNL currency object
    HNL: { code: "HNL", name: "Lempira" minorUnits: 2, factor: 100},
    // HTG currency object
    HTG: { code: "HTG", name: "Gourde" minorUnits: 2, factor: 100},
    // HUF currency object
    HUF: { code: "HUF", name: "Forint" minorUnits: 2, factor: 100},
    // IDR currency object
    IDR: { code: "IDR", name: "Rupiah" minorUnits: 2, factor: 100},
    // ILS currency object
    ILS: { code: "ILS", name: "New Israeli Sheqel" minorUnits: 2, factor: 100},
    // INR currency object
    INR: { code: "INR", name: "Indian Rupee" minorUnits: 2, factor: 100},
    // IQD currency object
    IQD: { code: "IQD", name: "Iraqi Dinar" minorUnits: 3, factor: 1000},
    // IRR currency object
    IRR: { code: "IRR", name: "Iranian Rial" minorUnits: 2, factor: 100},
    // ISK currency object
    ISK: { code: "ISK", name: "Iceland Krona" minorUnits: 0, factor: 1},
    // JMD currency object
    JMD: { code: "JMD", name: "Jamaican Dollar" minorUnits: 2, factor: 100},
    // JOD currency object
    JOD: { code: "JOD", name: "Jordanian Dinar" minorUnits: 3, factor: 1000},
    // JPY currency object
    JPY: { code: "JPY", name: "Yen" minorUnits: 0, factor: 1},
    // KES currency object
    KES: { code: "KES", name: "Kenyan Shilling" minorUnits: 2, factor: 100},
    // KGS currency object
    KGS: { code: "KGS", name: "Som" minorUnits: 2, factor: 100},
    // KHR currency object
    KHR: { code: "KHR", name: "Riel" minorUnits: 2, factor: 100},
    // KMF currency object
    KMF: { code: "KMF", name: "Comorian Franc " minorUnits: 0, factor: 1},
    // KPW currency object
    KPW: { code: "KPW", name: "North Korean Won" minorUnits: 2, factor: 100},
    // KRW currency object
    KRW: { code: "KRW", name: "Won" minorUnits: 0, factor: 1},
    // KWD currency object
    KWD: { code: "KWD", name: "Kuwaiti Dinar" minorUnits: 3, factor: 1000},
    // KYD currency object
    KYD: { code: "KYD", name: "Cayman Islands Dollar" minorUnits: 2, factor: 100},
    // KZT currency object
    KZT: { code: "KZT", name: "Tenge" minorUnits: 2, factor: 100},
    // LAK currency object
    LAK: { code: "LAK", name: "Lao Kip" minorUnits: 2, factor: 100},
    // LBP currency object
    LBP: { code: "LBP", name: "Lebanese Pound" minorUnits: 2, factor: 100},
    // LKR currency object
    LKR: { code: "LKR", name: "Sri Lanka Rupee" minorUnits: 2, factor: 100},
    // LRD currency object
    LRD: { code: "LRD", name: "Liberian Dollar" minorUnits: 2, factor: 100},
    // LSL currency object
    LSL: { code: "LSL", name: "Loti" minorUnits: 2, factor: 100},
    // LYD currency object
    LYD: { code: "LYD", name: "Libyan Dinar" minorUnits: 3, factor: 1000},
    // MAD currency object
    MAD: { code: "MAD", name: "Moroccan Dirham" minorUnits: 2, factor: 100},
    // MDL currency object
    MDL: { code: "MDL", name: "Moldovan Leu" minorUnits: 2, factor: 100},
    // MGA currency object
    MGA: { code: "MGA", name: "Malagasy Ariary" minorUnits: 2, factor: 100},
    // MKD currency object
    MKD: { code: "MKD", name: "Denar" minorUnits: 2, factor: 100},
    // MMK currency object
    MMK: { code: "MMK", name: "Kyat" minorUnits: 2, factor: 100},
    // MNT currency object
    MNT: { code: "MNT", name: "Tugrik" minorUnits: 2, factor: 100},
    // MOP currency object
    MOP: { code: "MOP", name: "Pataca" minorUnits: 2, factor: 100},
    // MRU currency object
    MRU: { code: "MRU", name: "Ouguiya" minorUnits: 2, factor: 100},
    // MUR currency object
    MUR: { code: "MUR", name: "Mauritius Rupee" minorUnits: 2, factor: 100},
    // MVR currency object
    MVR: { code: "MVR", name: "Rufiyaa" minorUnits: 2, factor: 100},
    // MWK currency object
    MWK: { code: "MWK", name: "Malawi Kwacha" minorUnits: 2, factor: 100},
    // MXN currency object
    MXN: { code: "MXN", name: "Mexican Peso" minorUnits: 2, factor: 100},
    // MXV currency object
    MXV: { code: "MXV", name: "Mexican Unidad de Inversion (UDI)" minorUnits: 2, factor: 100},
    // MYR currency object
    MYR: { code: "MYR", name: "Malaysian Ringgit" minorUnits: 2, factor: 100},
    // MZN currency object
    MZN: { code: "MZN", name: "Mozambique Metical" minorUnits: 2, factor: 100},
    // NAD currency object
    NAD: { code: "NAD", name: "Namibia Dollar" minorUnits: 2, factor: 100},
    // NGN currency object
    NGN: { code: "NGN", name: "Naira" minorUnits: 2, factor: 100},
    // NIO currency object
    NIO: { code: "NIO", name: "Cordoba Oro" minorUnits: 2, factor: 100},
    // NOK currency object
    NOK: { code: "NOK", name: "Norwegian Krone" minorUnits: 2, factor: 100},
    // NPR currency object
    NPR: { code: "NPR", name: "Nepalese Rupee" minorUnits: 2, factor: 100},
    // NZD currency object
    NZD: { code: "NZD", name: "New Zealand Dollar" minorUnits: 2, factor: 100},
    // OMR currency object
    OMR: { code: "OMR", name: "Rial Omani" minorUnits: 3, factor: 1000},
    // PAB currency object
    PAB: { code: "PAB", name: "Balboa" minorUnits: 2, factor: 100},
    // PEN currency object
    PEN: { code: "PEN", name: "Sol" minorUnits: 2, factor: 100},
    // PGK currency object
    PGK: { code: "PGK", name: "Kina" minorUnits: 2, factor: 100},
    // PHP currency object
    PHP: { code: "PHP", name: "Philippine Peso" minorUnits: 2, factor: 100},
    // PKR currency object
    PKR: { code: "PKR", name: "Pakistan Rupee" minorUnits: 2, factor: 100},
    // PLN currency object
    PLN: { code: "PLN", name: "Zloty" minorUnits: 2, factor: 100},
    // PYG currency object
    PYG: { code: "PYG", name: "Guarani" minorUnits: 0, factor: 1},
    // QAR currency object
    QAR: { code: "QAR", name: "Qatari Rial" minorUnits: 2, factor: 100},
    // RON currency object
    RON: { code: "RON", name: "Romanian Leu" minorUnits: 2, factor: 100},
    // RSD currency object
    RSD: { code: "RSD", name: "Serbian Dinar" minorUnits: 2, factor: 100},
    // RUB currency object
    RUB: { code: "RUB", name: "Russian Ruble" minorUnits: 2, factor: 100},
    // RWF currency object
    RWF: { code: "RWF", name: "Rwanda Franc" minorUnits: 0, factor: 1},
    // SAR currency object
    SAR: { code: "SAR", name: "Saudi Riyal" minorUnits: 2, factor: 100},
    // SBD currency object
    SBD: { code: "SBD", name: "Solomon Islands Dollar" minorUnits: 2, factor: 100},
    // SCR currency object
    SCR: { code: "SCR", name: "Seychelles Rupee" minorUnits: 2, factor: 100},
    // SDG currency object
    SDG: { code: "SDG", name: "Sudanese Pound" minorUnits: 2, factor: 100},
    // SEK currency object
    SEK: { code: "SEK", name: "Swedish Krona" minorUnits: 2, factor: 100},
    // SGD currency object
    SGD: { code: "SGD", name: "Singapore Dollar" minorUnits: 2, factor: 100},
    // SHP currency object
    SHP: { code: "SHP", name: "Saint Helena Pound" minorUnits: 2, factor: 100},
    // SLE currency object
    SLE: { code: "SLE", name: "Leone" minorUnits: 2, factor: 100},
    // SLL currency object
    SLL: { code: "SLL", name: "Leone" minorUnits: 2, factor: 100},
    // SOS currency object
    SOS: { code: "SOS", name: "Somali Shilling" minorUnits: 2, factor: 100},
    // SRD currency object
    SRD: { code: "SRD", name: "Surinam Dollar" minorUnits: 2, factor: 100},
    // SSP currency object
    SSP: { code: "SSP", name: "South Sudanese Pound" minorUnits: 2, factor: 100},
    // STN currency object
    STN: { code: "STN", name: "Dobra" minorUnits: 2, factor: 100},
    // SVC currency object
    SVC: { code: "SVC", name: "El Salvador Colon" minorUnits: 2, factor: 100},
    // SYP currency object
    SYP: { code: "SYP", name: "Syrian Pound" minorUnits: 2, factor: 100},
    // SZL currency object
    SZL: { code: "SZL", name: "Lilangeni" minorUnits: 2, factor: 100},
    // THB currency object
    THB: { code: "THB", name: "Baht" minorUnits: 2, factor: 100},
    // TJS currency object
    TJS: { code: "TJS", name: "Somoni" minorUnits: 2, factor: 100},
    // TMT currency object
    TMT: { code: "TMT", name: "Turkmenistan New Manat" minorUnits: 2, factor: 100},
    // TND currency object
    TND: { code: "TND", name: "Tunisian Dinar" minorUnits: 3, factor: 1000},
    // TOP currency object
    TOP: { code: "TOP", name: "Pa’anga" minorUnits: 2, factor: 100},
    // TRY currency object
    TRY: { code: "TRY", name: "Turkish Lira" minorUnits: 2, factor: 100},
    // TTD currency object
    TTD: { code: "TTD", name: "Trinidad and Tobago Dollar" minorUnits: 2, factor: 100},
    // TWD currency object
    TWD: { code: "TWD", name: "New Taiwan Dollar" minorUnits: 2, factor: 100},
    // TZS currency object
    TZS: { code: "TZS", name: "Tanzanian Shilling" minorUnits: 2, factor: 100},
    // UAH currency object
    UAH: { code: "UAH", name: "Hryvnia" minorUnits: 2, factor: 100},
    // UGX currency object
    UGX: { code: "UGX", name: "Uganda Shilling" minorUnits: 0, factor: 1},
    // USD currency object
    USD: { code: "USD", name: "US Dollar" minorUnits: 2, factor: 100},
    // USN currency object
    USN: { code: "USN", name: "US Dollar (Next day)" minorUnits: 2, factor: 100},
    // UYI currency object
    UYI: { code: "UYI", name: "Uruguay Peso en Unidades Indexadas (UI)" minorUnits: 0, factor: 1},
    // UYU currency object
    UYU: { code: "UYU", name: "Peso Uruguayo" minorUnits: 2, factor: 100},
    // UYW currency object
    UYW: { code: "UYW", name: "Unidad Previsional" minorUnits: 4, factor: 10000},
    // UZS currency object
    UZS: { code: "UZS", name: "Uzbekistan Sum" minorUnits: 2, factor: 100},
    // VED currency object
    VED: { code: "VED", name: "Bolívar Soberano" minorUnits: 2, factor: 100},
    // VES currency object
    VES: { code: "VES", name: "Bolívar Soberano" minorUnits: 2, factor: 100},
    // VND currency object
    VND: { code: "VND", name: "Dong" minorUnits: 0, factor: 1},
    // VUV currency object
    VUV: { code: "VUV", name: "Vatu" minorUnits: 0, factor: 1},
    // WST currency object
    WST: { code: "WST", name: "Tala" minorUnits: 2, factor: 100},
    // XAF currency object
    XAF: { code: "XAF", name: "CFA Franc BEAC" minorUnits: 0, factor: 1},
    // XAG currency object
    XAG: { code: "XAG", name: "Silver" minorUnits: 0, factor: 1},
    // XAU currency object
    XAU: { code: "XAU", name: "Gold" minorUnits: 0, factor: 1},
    // XBA currency object
    XBA: { code: "XBA", name: "Bond Markets Unit European Composite Unit (EURCO)" minorUnits: 0, factor: 1},
    // XBB currency object
    XBB: { code: "XBB", name: "Bond Markets Unit European Monetary Unit (E.M.U.-6)" minorUnits: 0, factor: 1},
    // XBC currency object
    XBC: { code: "XBC", name: "Bond Markets Unit European Unit of Account 9 (E.U.A.-9)" minorUnits: 0, factor: 1},
    // XBD currency object
    XBD: { code: "XBD", name: "Bond Markets Unit European Unit of Account 17 (E.U.A.-17)" minorUnits: 0, factor: 1},
    // XCD currency object
    XCD: { code: "XCD", name: "East Caribbean Dollar" minorUnits: 2, factor: 100},
    // XDR currency object
    XDR: { code: "XDR", name: "SDR (Special Drawing Right)" minorUnits: 0, factor: 1},
    // XOF currency object
    XOF: { code: "XOF", name: "CFA Franc BCEAO" minorUnits: 0, factor: 1},
    // XPD currency object
    XPD: { code: "XPD", name: "Palladium" minorUnits: 0, factor: 1},
    // XPF currency object
    XPF: { code: "XPF", name: "CFP Franc" minorUnits: 0, factor: 1},
    // XPT currency object
    XPT: { code: "XPT", name: "Platinum" minorUnits: 0, factor: 1},
    // XSU currency object
    XSU: { code: "XSU", name: "Sucre" minorUnits: 0, factor: 1},
    // XTS currency object
    XTS: { code: "XTS", name: "Codes specifically reserved for testing purposes" minorUnits: 0, factor: 1},
    // XUA currency object
    XUA: { code: "XUA", name: "ADB Unit of Account" minorUnits: 0, factor: 1},
    // XXX currency object
    XXX: { code: "XXX", name: "The codes assigned for transactions where no currency is involved" minorUnits: 0, factor: 1},
    // YER currency object
    YER: { code: "YER", name: "Yemeni Rial" minorUnits: 2, factor: 100},
    // ZAR currency object
    ZAR: { code: "ZAR", name: "Rand" minorUnits: 2, factor: 100},
    // ZMW currency object
    ZMW: { code: "ZMW", name: "Zambian Kwacha" minorUnits: 2, factor: 100},
    // ZWL currency object
    ZWL: { code: "ZWL", name: "Zimbabwe Dollar" minorUnits: 2, factor: 100}
    };